unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, FileCtrl, ExtCtrls;

const
  FILE_DEVICE_DISK               =  $00000007;
  FILE_ANY_ACCESS                =  0;

  METHOD_BUFFERED                =  0;
  IOCTL_DISK_BASE                = FILE_DEVICE_DISK;
  IOCTL_DISK_GET_DRIVE_GEOMETRY  = ( ((IOCTL_DISK_BASE) SHL 16) OR ((FILE_ANY_ACCESS) SHL 14) OR (($0000) SHL 2) OR (METHOD_BUFFERED) );

type
  Tdirentry = packed record
      name : array[0..15] of Char;
      ext : array[0..3] of Char;
      fsize : DWord;
      firstsect : Word;
      attr : Word;
      Reserved : DWord;
      end;
  PDirEntry = ^TDirEntry;

  PLARGE_INTEGER = ^LARGE_INTEGER;
  LARGE_INTEGER = packed record
	LowPart: dword;
	HighPart: dword;
  end;

  PDISK_GEOMETRY = ^TDISK_GEOMETRY;
  TDISK_GEOMETRY = packed record
    Cylinders: LARGE_INTEGER;
    MediaType: dword;
    TracksPerCylinder: dword;
    SectorsPerTrack: dword;
    BytesPerSector: dword;
  end;

  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    ListView1: TListView;
    DriveComboBox1: TDriveComboBox;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Button4: TButton;
    SaveDialog1: TSaveDialog;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Button6: TButton;
    Label3: TLabel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    function ReadSector(sid : Cardinal) : Boolean;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function CopyFileOut(dest : TStream) : Boolean;
    function CopyFileIn(src : TStream; nam : string) : Boolean;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure UpDateFAT;
    function AllocFAT : Word;
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormatDisk;
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    devopen : Boolean;
    sbuf : array[0..2048] of Byte;
    fat : PWord;
    Drive : Char;

    fat_begin, fat_end : word;
    root_begin, root_end : word;
  end;

var
  Form1: TForm1;
    hdevice: thandle; hdrv : char;
    hlacc : Cardinal;

implementation

uses Unit2;

{$R *.DFM}
{$R BOOT.RES}

function NT_Read(drv: char; LBA: longint; blocks: byte; buf: pointer): boolean;
var
  res: boolean;
  bytestoread, numread: dword;
  dwpointer: dword;
  ldistancelow, ldistancehigh: dword;
begin
  res:=false;
  if drv <> hdrv then
    if hdevice <> 0 then
        begin
        CloseHandle(hdevice);
        hdevice := 0;
        end;
  hdrv := drv;
  hlacc := GetTickCount;
  if hdevice = 0 then
      hDevice:=CreateFile(pchar('\\.\'+UpCase(drv)+':'), GENERIC_READ or GENERIC_WRITE, {FILE_SHARE_READ OR} FILE_SHARE_WRITE,
    nil, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH, 0);
  if hDevice <> INVALID_HANDLE_VALUE then
  begin
    ldistanceLow:=dword(LBA SHL 9);
    ldistanceHigh:=dword(LBA SHR (32-9));
    dwpointer:=SetFilePointer(hdevice, ldistancelow, @ldistancehigh, FILE_BEGIN);
    if dwPointer <> $FFFFFFFF then
    begin
      bytestoread:=blocks*512;
      res:=ReadFile(hDevice, buf^, bytestoread, numread, nil);

      if not res then
      begin
{        err:=GetLastError;
        messagebox(0, pchar('error no.'+inttostr(err)+#13#10+'drv:'+drv+' LBA:'+inttostr(LBA)
          +' blocks:'+inttostr(blocks) ), 'NT_read error', mb_ok);}
      end;
    end;
//    CloseHandle(hDevice);
  end;
  NT_Read:=(res) AND (numread=blocks*512);
end;

function NT_Write(drv: char; LBA: longint; blocks: byte; buf: pointer): boolean;
var
  res: boolean;
  bytestoread, numread: dword;
  dwpointer: dword;
  ldistancelow, ldistancehigh: dword;
begin
  res:=false;
  if drv <> hdrv then
    if hdevice <> 0 then
        begin
        CloseHandle(hdevice);
        hdevice := 0;
        end;
  hlacc := GetTickCount;
  if hdevice = 0 then
  hDevice:=CreateFile(pchar('\\.\'+UpCase(drv)+':'), GENERIC_READ or GENERIC_WRITE, {FILE_SHARE_READ OR} FILE_SHARE_WRITE,
    nil, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH, 0);
  if hDevice <> INVALID_HANDLE_VALUE then
  begin
    ldistanceLow:=dword(LBA SHL 9);
    ldistanceHigh:=dword(LBA SHR (32-9));
    dwpointer:=SetFilePointer(hdevice, ldistancelow, @ldistancehigh, FILE_BEGIN);
    if dwPointer <> $FFFFFFFF then
    begin
      bytestoread:=blocks*512;
      res:=WriteFile(hDevice, buf^, bytestoread, numread, nil);

      if not res then
      begin
{        err:=GetLastError;
        messagebox(0, pchar('error no.'+inttostr(err)+#13#10+'drv:'+drv+' LBA:'+inttostr(LBA)
          +' blocks:'+inttostr(blocks) ), 'NT_read error', mb_ok);}
      end;
    end;
//    CloseHandle(hDevice);
  end;
  NT_Write:=(res) AND (numread=blocks*512);
end;

function NT_GetDriveGeometry(drv: char; dg: PDISK_GEOMETRY): boolean;
var
  hDevice: thandle;
  fResult: boolean;
  cb: DWORD;
begin
    fResult:=false;
    hDevice := CreateFile(pchar('\\.\'+UpCase(drv)+':'),
        0, FILE_SHARE_READ OR FILE_SHARE_WRITE,
        nil, OPEN_EXISTING, 0, 0);

    if (hDevice <> 0) then
    begin
      fResult := DeviceIoControl(hDevice,
        IOCTL_DISK_GET_DRIVE_GEOMETRY, nil, 0,
        dg, sizeof(TDISK_GEOMETRY), cb, nil);
    end;

    CloseHandle(hDevice);
    NT_GetDriveGeometry:=fResult;
end;

procedure TForm1.FormatDisk;
var
   geo : TDISK_GEOMETRY;
   rptr : Pointer;
   i,numlba : Word;
begin
Label1.Caption := 'Getting geometry';
Label1.Repaint;
NT_GetDriveGeometry(drive,@geo);
if geo.BytesPerSector <> 512 then
   begin
   showmessage('Sectorsize wrong! Needs to be 512 bytes');
   exit;
   end;
rptr := LockResource(LoadResource(hInstance,FindResource(hInstance,'BSEC','RT_RCDATA')));
move(rptr^,sbuf,512);
sbuf[4] := geo.SectorsPerTrack;
sbuf[5] := geo.TracksPerCylinder;
numlba := geo.Cylinders.LowPart * geo.TracksPerCylinder * geo.SectorsPerTrack;
showmessage('Diskformat: C/H/S=' + inttostr(geo.Cylinders.LowPart) + '/' + inttostr(geo.TracksPerCylinder) + '/' + inttostr(geo.SectorsPerTrack) + ' LBA=' + inttostr(numlba));
sbuf[10] := ((numlba + 255) div 256) + 1;
sbuf[11] := 0;
sbuf[12] := sbuf[10] + 8;
sbuf[13] := 0;
Label1.Caption := 'Writing bootsector';
Label1.Repaint;
NT_Write(drive,0,1,@sbuf);
{}
fat_begin := 1;
root_begin := sbuf[10];
fat_end := root_begin - 1;
root_end := sbuf[12] - 1;

for i := 0 to 511 do sbuf[i] := 0;
Label1.Caption := 'Writing empty FAT';
Label1.Repaint;
for i := fat_begin to fat_end do
    NT_Write(drive,i,1,@sbuf);
for i := 0 to 511 do
    if (i mod 32) < 16 then
       sbuf[i] := 32
    else
        sbuf[i] := 0;
Label1.Caption := 'Writing empty root';
Label1.Repaint;
for i := root_begin to root_end do
    NT_Write(drive,i,1,@sbuf);
Label1.Caption := 'Allocating System-Areas';
Label1.Repaint;
sleep(250);
if fat <> nil then freemem(fat);
getmem(fat, 512*(fat_end-fat_begin+1));
for i := 0 to root_end do
    PWord(Cardinal(fat)+i*2)^ := 1;
for i := (root_end + 1) to (numlba - 1) do
    PWord(Cardinal(fat)+i*2)^ := 0;
UpdateFAT;
Button1Click(self);
end;

function TForm1.AllocFAT : Word;
var
   i : integer;
begin
for i := 0 to (fat_end-fat_begin+1)*256 do
    if PWord(Cardinal(fat)+i*2)^ = 0 then
       begin
       PWord(Cardinal(fat)+i*2)^ := 1;
       Result := i;
       exit;
       end;
Result := 65535;
end;

function MkString(wh : Pchar; len : integer) : string;
begin
SetString(Result,wh,len);
Result := Trim(Result);
end;

procedure UnMkString(dest : PChar; str : string; len : integer);
begin
while length(str) < len do
      str := str + ' ';
str := copy(str,1,len);
move(pchar(str)^,dest^,len);
end;

function TForm1.ReadSector(sid : Cardinal) : Boolean;
begin
// result := ExtendedRead(Byte(UpCase(drive))-65,sid,1,@sbuf);
result := NT_Read(drive,sid,1,@sbuf);
end;

function TForm1.CopyFileIn(src : TStream;nam : string) : Boolean;
var
   i,j : Integer;
   a,b : string;
   dirent : TDirEntry;
   byteleft : DWord;
   cb : Word;
   cursec,nsec,osec : Word;
begin
// 1. Parse the Name
nam := uppercase(nam);
i := pos('.',nam);
if i = 0 then
   begin
   a := nam;
   b := '';
   UnMkString(@dirent.name,nam,20);
   end
else
    begin
    a := copy(nam,1,i-1);
    b := copy(nam,i+1,4);
    UnMkString(@(dirent.name),a,16);
    UnMkString(@(dirent.ext),b,4);
    end;
for i := 0 to listview1.Items.Count - 1 do
    if listview1.Items[i].Caption = a then
       if listview1.Items[i].subitems[0] = b then
          begin
          showmessage('File already exists. Delete it first!');
          Result := False;
          exit;
          end;
dirent.fsize := src.Size;
byteleft := src.Size;
dirent.firstsect := AllocFAT;
cursec := dirent.firstsect;
osec := cursec;
dirent.attr := 3;
dirent.Reserved := 0;
nsec := 65535;
while byteleft > 0 do
      begin
      Label1.Caption := 'Writing ' + inttostr(cursec) + ' Byte left:' + inttostr(byteleft);
      Label1.Repaint;
      if byteleft > 512 then cb := 512 else cb := byteleft;
      src.Read(sbuf,cb);
      if NT_Write(drive,cursec,1,@sbuf) = False then
         begin
         showmessage('Write failed! Out of diskspace? I have to reload the entire medium. Press OK');
         Button1Click(self);
         Result := False;
         exit;
         end;
      nsec := AllocFat;
      PWord(Cardinal(fat)+cursec*2)^ := nsec;
      osec := cursec; cursec := nsec;
      dec(byteleft,cb);
      end;

PWord(Cardinal(fat)+osec*2)^ := $FFFF;
if nsec <> 65535 then PWord(Cardinal(fat)+nsec*2)^ := $0000;
Label1.Caption := 'Wrting Directory-Entry';
Label1.Repaint;
for i := root_begin to root_end do
    begin
    ReadSector(i);
    for j := 0 to 15 do
        if sbuf[j*32] = 32 then
           begin
           move(dirent,sbuf[j*32],32);
           NT_Write(drive,i,1,@sbuf);
           UpDateFat;
           Button2Click(self);
           Result := True;
           exit;
           end
    end;
ShowMessage('FAILED! No free dir-entry? I have to reload the medium. Press OK');
Button1Click(self);
Result := False;
end;

function TForm1.CopyFileOut(dest : TStream) : Boolean;
var
   cursec : Word;
   byteleft : DWord;
   cb : Word;
begin
Result := False;
if listview1.selected = nil then exit;
byteleft := strtoint(listview1.selected.subitems[1]);
cursec := strtoint(listview1.selected.subitems[3]);
while byteleft > 0 do
      begin
      label1.Caption := 'Reading ' + inttostr(cursec) + ' Byte left:' + inttostr(byteleft);
      label1.Repaint;
      if ReadSector(cursec) = False then
         begin
         showmessage('ERROR reading disk');
         devopen := False;
         exit;
         end;
      if byteleft > 512 then cb := 512 else cb := byteleft;
      dest.Write(sbuf,cb);
      dec(byteleft,cb);
      cursec := pword(cardinal(fat)+(cursec*2))^;
      end;
Label1.Caption := 'Ready';
Result := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
label
     diskok,
     formdisk;
var
   c : cardinal;
begin
listview1.Items.Clear;
devopen := False;
label1.Caption := 'Checking disk';
label1.Repaint;
Drive := drivecombobox1.Drive;
{if DirDisk1.BytesPerSector <> 512 then
   begin
   showmessage('Wrong sectorsize (needs to bs 512 Byte)');
   label1.caption := 'Error';
   exit;
   end;}

if ReadSector(0) = False then
   begin
   devopen := False;
   showmessage('Error reading bootsector. Maybe there''s no disk in the drive or it is damaged');
   label1.caption := '<<<< Device physically damaged!!!! >>>>';
   exit;
   end;

if ReadSector(65500) then
   begin
   devopen := False;
   showmessage('Device is larger than 32MB and is not compatible with DS-FS');
   label1.caption := 'Error';
   exit;
   end;
label1.Caption := 'Getting parameters';
label1.Repaint;
if ReadSector(0) = False then
   begin
   devopen := False;
   showmessage('Error reading bootsector. Throw the disk away');
   label1.caption := '<<<< Device physically damaged!!!! >>>>';
   exit;
   end;
for c := 0 to 505 do
    if sbuf[c] = Byte('O') then
       if sbuf[c+1] = Byte('S') then
          if sbuf[c+2] = Byte('.')   then
             if sbuf[c+3] = Byte('S') then
                if sbuf[c+4] = Byte('Y') then
                   if sbuf[c+5] = Byte('S') then
                      goto diskok;
formdisk:
devopen := False;
if Application.MessageBox('This is no DS-OS Disk. Would you like to create the DS-FS Filesystem (ALL DATA WILL BE LOST!!!!)','FS-Error',MB_YESNO) = IDYES then
   begin
   Formatdisk;
   exit;
   end;
// showmessage('NO DS-FS Filesystem found');
label1.Caption := 'Wrong FS';
diskok:
label1.Caption := 'Reading FAT';
label1.Repaint;

fat_begin := 1;
root_begin := sbuf[10] + (sbuf[11] shl 8);
fat_end := root_begin - 1;
root_end := (sbuf[12] + (sbuf[13] shl 8)) - 1;

if fat <> nil then freemem(fat);
getmem(fat, 512*(fat_end-fat_begin+1));
if NT_Read(drive,fat_begin,(fat_end-fat_begin+1),fat) = False then
   begin
   devopen := False;
   showmessage('Error reading FAT');
   label1.Caption := 'ERROR';
   label1.Repaint;
   goto formdisk;
   exit;
   end;
devopen := True;
Button2Click(sender);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   i,ie : word;
   li : TListItem;
   s : string;
   tbuf : PDirEntry;
   ent : PDirEntry;
begin
if devopen = False then
   begin
   button1click(self);
   exit;
   end;
label1.Caption := 'Reading Directory';
label1.Repaint;
listview1.Items.Clear;
GetMem(tbuf,512*(root_end-root_begin+1));
if NT_Read(drive,root_begin,(root_end-root_begin+1),tbuf) = False then
   begin
   devopen := False;
   showmessage('Error reading root');
   label1.Caption := 'ERROR';
   label1.Repaint;
   exit;
   end;
ie := (root_end-root_begin+1)*8;

for i := 0 to ie do
    begin
        ent := PDirEntry(Cardinal(tbuf)+i*32);
        if (ent^.name[0] <> ' ') and (ent^.name[0] <> char(0)) then
           begin
           li := listview1.Items.Add;
           li.caption := mkstring(ent^.name,16);
           li.SubItems.Add(mkstring(ent^.ext,4));
           li.SubItems.Add(inttostr(ent^.fsize));
           if (ent^.attr and 1) <> 0 then
              s := 'R' else s := '';
           if (ent^.attr and 2) <> 0 then
              s := s + 'W';
           li.SubItems.Add(s);
           li.SubItems.Add(inttostr(ent^.firstsect));
           li.SubItems.Add(inttostr(i));
           end;
    end;
FreeMem(tbuf);
label1.Caption := 'Ready';
label1.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
hdevice := 0;
DriveCombobox1.Drive := 'A';
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   f : TFileStream;
begin
if not devopen then button1click(sender);
if not devopen then exit;
if listview1.Selected = nil then exit;

f := TFileStream.Create('C:\DSFS.TMP',fmCreate);
CopyFileOut(f);
f.free;
winexec('notepad C:\DSFS.TMP',SW_SHOWNORMAL);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
   f : TFileStream;
begin
if not devopen then button1click(sender);
if not devopen then exit;
if listview1.Selected = nil then exit;

if savedialog1.Execute then
   begin
   f := TFileStream.Create(savedialog1.FileName,fmCreate);
   CopyFileOut(f);
   f.free;
   end;
end;

procedure TForm1.UpDateFAT;
begin
Label1.Caption := 'Updating FAT';
Label1.Repaint;
NT_Write(drive,fat_begin,(fat_end-fat_begin+1),fat);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
   f : TFileStream;
   a : string;
begin
if not devopen then button1click(sender);
if not devopen then exit;

if opendialog1.Execute then
   begin
   a := InputBox('New Name','Enter filename (16.4)','');
   if a = '' then exit;
   f := TFileStream.Create(OpenDialog1.filename,fmOpenRead);
   CopyFileIn(f,a);
   f.Free;
   end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
   id,s : Word;
   cursec,osec : Word;
begin
if not devopen then button1click(sender);
if not devopen then exit;
if listview1.Selected = nil then exit;

Label1.Caption := 'Deleting chain';
Label1.Repaint;
sleep(250);
cursec := strtoint(listview1.Selected.SubItems[3]);
id := strtoint(listview1.Selected.SubItems[4]);
while true do
      begin
      osec := PWord(Cardinal(fat)+cursec*2)^;
      PWord(Cardinal(fat)+cursec*2)^ := 0;
      if (osec = $FFFF) or (osec = 0) then break;
      cursec := osec;
      end;
UpDateFat;
Label1.Caption := 'Removing entry';
Label1.Repaint;
s := id div 16;
id := id - (s * 8);
id := id * 32;
ReadSector(s+root_begin);
FillChar(PChar(id+DWord(@sbuf))^,16,32);
FillChar(PChar(id+DWord(@sbuf)+16)^,16,0);
NT_Write(drive,s+root_begin,1,@sbuf);
Button2Click(self);
end;

procedure TForm1.Button7Click(Sender: TObject);
var
   i,id,s : Word;
   nam : string;
begin
if not devopen then button1click(sender);
if not devopen then exit;
if listview1.Selected = nil then exit;
nam := InputBox('Rename','Enter new filename (16.4)','');
if nam = '' then exit;

Label1.Caption := 'Reading entry';
Label1.Repaint;

id := strtoint(listview1.Selected.SubItems[4]);
s := id div 16;
id := id - (s * 8);
id := id * 32;
ReadSector(s+root_begin);

nam := uppercase(nam);
i := pos('.',nam);
if i = 0 then
   UnMkString(Pchar(Cardinal(@sbuf)+id),nam,20)
else
    begin
    UnMkString(Pchar(Cardinal(@sbuf)+id),copy(nam,1,i-1),16);
    UnMkString(Pchar(Cardinal(@sbuf)+id+16),copy(nam,i+1,4),4);
    end;
Label1.Caption := 'Writing entry';
Label1.Repaint;
NT_Write(drive,s+root_begin,1,@sbuf);
Button2Click(self);
end;

procedure TForm1.Button8Click(Sender: TObject);
var
   id,s : Word;
   attr : Word;
begin
if not devopen then button1click(sender);
if not devopen then exit;
if listview1.Selected = nil then exit;

Label1.Caption := 'Reading entry';
Label1.Repaint;

id := strtoint(listview1.Selected.SubItems[4]);
s := id div 16;
id := id - (s * 8);
id := id * 32;
ReadSector(s+root_begin);

attr := PWord(Cardinal(@sbuf)+id+26)^;
form2.CheckBox1.Checked := (attr and 1) <> 0;
form2.CheckBox2.Checked := (attr and 2) <> 0;
if form2.ShowModal = mrCancel then
   begin
   Label1.Caption := 'Ready';
   exit;
   end;
if form2.CheckBox1.Checked then attr := 1 else attr := 0;
if form2.CheckBox2.Checked then attr := attr or 2;
PWord(Cardinal(@sbuf)+id+26)^ := attr;

Label1.Caption := 'Writing entry';
Label1.Repaint;
NT_Write(drive,s+root_begin,1,@sbuf);
Button2Click(self);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
if not devopen then showmessage('Click Apply first');
if not devopen then exit;

if Application.MessageBox('Are you sure? ALL DATA WILL BE LOST!!!!','Format Disk',MB_YESNO) = IDYES then
   Formatdisk;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if hdevice <> 0 then
    if GetTickCount > (hlacc + 1000) then
        begin
        CloseHandle(hdevice);
        hdevice := 0;
        end;
end;

end.
